// MIL80_OnBoardMem_Change.cpp : Defines the entry point for the console application.
//

/******************************************************************************/
/*
Check on board shared memory, set it to 64MB
version 1.0
Rui Bi
2010/09/15
 */
//#define MemToSet 256
//#define MemToSet 128
#define MemToSet 64
//#define MemToSet 32
//#define MemToSet 16

#include <conio.h>
#include <mil.h>

void main(void)
{
   MIL_ID MilApplication,  /* Application identifier.  */
          MilSystem0,
		  MilSystem1;      /* System identifier.       */

   long shared_mem_size=0;
   int resetFlag =0;

   long shared_mem_size1=0;
   int resetFlag1 =0;

   MappAlloc(M_DEFAULT, &MilApplication);
   
   MappControl(M_ERROR, M_PRINT_DISABLE);

   MsysAlloc(M_SYSTEM_SOLIOS, M_DEV0, M_DEFAULT, &MilSystem0);
//   MsysAlloc(M_SYSTEM_SOLIOS, M_DEV1, M_DEFAULT, &MilSystem1);
   
   MappControl(M_ERROR, M_PRINT_ENABLE);

   printf("checkmemory 1.0\n\n");
   
   shared_mem_size = MsysInquire(MilSystem0, M_SHARED_MEMORY_SIZE, M_NULL);
//   shared_mem_size1 = MsysInquire(MilSystem1, M_SHARED_MEMORY_SIZE, M_NULL);

   printf("Solios_0 : Shared on-board memory size is %d MB\n", shared_mem_size);
 //  printf("Solios_1 : Shared on-board memory size is %d MB\n", shared_mem_size1);

   printf("\n\nDo you want to change the on-board memory size?\n");
   printf("Press <Enter> to continue.\n");
   getch();
   
   if (shared_mem_size !=MemToSet)
   {
	   printf("\nSolios_0 :Press <Enter> to set it to %d MB.\n",MemToSet);
	   getch();
	   shared_mem_size = MemToSet;
   	   MsysControl(MilSystem0, M_SHARED_MEMORY_SIZE, shared_mem_size);
	   resetFlag =1;
	   printf("Done!\n");
   }

/*   if (shared_mem_size1 !=MemToSet)
   {
	   printf("\nSolios_1 :Press <Enter> to set it to %d MB.\n",MemToSet);
	   getch();
	   shared_mem_size1 = MemToSet;
   	   MsysControl(MilSystem1, M_SHARED_MEMORY_SIZE, shared_mem_size1);
	   resetFlag =1;
	   printf("Done!\n");
   }
*/
   if(resetFlag)
   {
	   printf("\n=================================================================");
	   printf("\nPlease shutdown the system.\n");
	   printf("Then turn on the system, use MtxDmaMemoryChecker to optimize Dma.\n");
	   printf("Then shutdown the system again.\n");
	   printf("=================================================================\n");
   }

   printf("\nPress <Enter> to finish.\n");
   getch();

   MsysFree(MilSystem0);
 //  MsysFree(MilSystem1);
   MappFree(MilApplication);   
}


